#include "expr.hh"

void SubstituteExprLabel(expression*& e, const std::string& name, long value)
{
    if(expr_label* l = dynamic_cast<expr_label*> (e))
    {
        if(l->GetName() == name)
        {
            e = new expr_number(value);
            delete l;
        }
    }
    else if(expr_unary* u = dynamic_cast<expr_unary*> (e))
    {
        SubstituteExprLabel(u->sub, name, value);
    }
    else if(expr_binary* b = dynamic_cast<expr_binary*> (e))
    {
        SubstituteExprLabel(b->left, name, value);
        SubstituteExprLabel(b->right, name, value);
    }
}

void FindExprUsedLabels(const expression* e, std::set<std::string>& labels)
{
    if(const expr_label* l = dynamic_cast<const expr_label*> (e))
    {
        labels.insert(l->GetName());
    }
    else if(const expr_unary* u = dynamic_cast<const expr_unary*> (e))
    {
        FindExprUsedLabels(u->sub, labels);
    }
    else if(const expr_binary* b = dynamic_cast<const expr_binary*> (e))
    {
        FindExprUsedLabels(b->left, labels);
        FindExprUsedLabels(b->right, labels);
    }
}
